function X = trirnd(P,varargin);
a=P(1);c=P(2);b=P(3);
%TRIRND Random arrays from triagle distribution.
%   R = TRIRND(A,C,B) returns an array of random numbers chosen from the
%   triangle distribution A-C-B. The size of R is the common size of 
%   A, B and C if both are arrays.  If either parameter is a scalar, the size
%   of R is the size of the other parameter.
%
%   R = TRIRND(A,C,B,M,N,...) or R = TRIRND(A,C,B,[M,N,...]) returns an
%   M-by-N-by-... array.
%
%   Copyright 2014, Rudolf Frhwirth 

if nargin < 3
    error('stats:trifrnd:TooFewInputs','Requires at least three input arguments.'); 
end

[err, sizeOut] = statsizechk1(3,a,c,b,varargin{:});

if err > 0
    error('stats:trirnd:InputSizeMismatch','Size information is inconsistent.');
end

X=zeros(sizeOut);
z=rand(sizeOut);

i = sqrt(z*(b-a)*(c-a))+a<c;
X(i) = sqrt(z(i)*(b-a)*(c-a))+a;
X(~i) = b-sqrt((1-z(~i))*(b-a)*(b-c));

end %function